using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using System.Threading;
using System.IO;
using System.Diagnostics;
using System.Text.RegularExpressions;
using System.Net;
using System.Net.Sockets;

namespace PhidgetLauncher
{

	public class MainForm : System.Windows.Forms.Form
	{
		#region GUIR|[lg̐錾
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TextBox textBoxId;
		private System.Windows.Forms.Label labelId;
		private System.Windows.Forms.Label labelRegistedId;
		private System.Windows.Forms.Button buttonRegister;
		private System.Windows.Forms.TabControl tabControl;
		private System.Windows.Forms.TabPage tabPageId;
		private System.Windows.Forms.StatusBar statusBar;
		private System.Windows.Forms.ListView listViewId;
		private System.Windows.Forms.ColumnHeader columnHeaderId;
		private System.Windows.Forms.ColumnHeader columnHeaderName;
		private System.Windows.Forms.TextBox textBoxMessage;
		private System.Windows.Forms.CheckBox checkBoxMessage;
		private System.Windows.Forms.TabPage tabPageDebug;
		private System.Windows.Forms.GroupBox groupBoxNet;
		private System.Windows.Forms.NumericUpDown numericUpDownPort;
		private System.Windows.Forms.Label labelPort;
		private System.Windows.Forms.Label labelIp;
		private System.Windows.Forms.TextBox textBoxIp;
		private System.Windows.Forms.Button buttonConnect;
		private System.Windows.Forms.Button buttonDisconnect;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.CheckBox checkBoxEvent;
		#endregion

		#region ϐ/萔

		//eLXg{bNX̍ő\
		const int TEXTBOX_CNT_MAX = 10000;
		
		//Aǂݎp̃Xbh
		Thread rxThread = null;
		
		//APolling̃ftHgl(msec)
		const int RX_THREAD_INTERVAL = 100;
		
		//APolling̊Ԋu
		int rxThreadInterval = RX_THREAD_INTERVAL;

		//PhidgetServer֐ڑ邽߂TCP Client
		TcpClient phidgetClient = null;
		//Cxg
		bool eventEnabled = false;

		//ACeo^pHashtable
		Hashtable itemHolder = new Hashtable();
		//ACeXg̕ۑt@C
		string itemFileName = Application.StartupPath + @"\items.txt";
		//ݒ̕ۑt@C
		string settingFileName = Application.StartupPath + @"\setting.txt";

		//OR}hĂяop̃vZX
		Process extProcess = null;
		//OvZXĂяoƂɎg_~[Xbh
		Thread extThread =null;
		//CxgɗpACe
		Item eventItem = null;

		//private const string DELIMITER = "&";

		//FẼCxg擾
		bool eventWorkingStart = false;
		bool eventWorkingEnd = false;

		//菜ɃCxgJntO
		string removedEventId = "0";

		//ݑIĂACẽf[^
		string currentProgram = "";
		string []currentOptions = null;
		//݂IDێϐ
		string  currentId = "0";
		
		//bZ[Wێϐ
		string message = "";
		//Xe[^Xo[̃bZ[Wpϐ
		string statusMessage = "";
		//bZ[Wo͂̃tO
		bool messageEnabled = true;

		#endregion

		#region RXgN^/fXgN^
			
		public MainForm()
		{
			InitializeComponent();
			LoadSettings();
			LoadItems();
			checkBoxMessage.Checked =  messageEnabled; 
			checkBoxEvent.Checked = eventEnabled;				
			return;
		}

		protected override void Dispose( bool disposing )
		{
			SaveItems();
			SaveSettings();

			if(extThread != null)
				extThread.Abort();
			StopThread();
			
			if(phidgetClient!=null)
				phidgetClient.Close();
	
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}

			base.Dispose( disposing );
		}
		#endregion

		#region Cxgp̃Xbh
		//CxgD
		private void DealEvent(Item item)
		{	
			if(item == null &&extThread != null)
			{
				extThread.Abort();
				extThread.Join();
				extThread = null;
			}
			else if(item != null && extThread ==null)
			{
				eventItem = item;
				extThread = new Thread(new ThreadStart(DealEventWorker));
				extThread.Start();
			}
		}

		//Cxgp̃XbhD
		private void DealEventWorker()
		{
			//OvZX̋N
			try
			{
				if(eventItem !=null)
				{
					extProcess = new Process();
					extProcess.EnableRaisingEvents = false;			//OvZXIɃCxg𔭐邩H
					extProcess.StartInfo.FileName = currentProgram;	//Nt@C
					extProcess.StartInfo.UseShellExecute = false;	
					foreach(string option in currentOptions)
					{
						extProcess.StartInfo.Arguments = extProcess.StartInfo.Arguments + " " + option;
					}
					extProcess.Start();
				}
				//I܂őҋ@
				while(true)
				{	
					Thread.Sleep(100);
				}
			}	
			catch(ThreadAbortException ex)
			{
			}
			catch(Exception ex)
			{
				PrintError(ex.ToString());
			}
			finally
			{
				//OvZXIDǂ猻݂̃XbhIĂ܂݂D
				if(extProcess!=null)
					extProcess.Kill();
				extThread.Abort();
				extThread = null;
			}		
		}
		#endregion

		#region ID̃}b`OƃCxgJn/~
		private bool CheckMatchId(string id)
		{
			if(id == "0")
			{
				if(currentId != "0")
				{
					if(eventEnabled)
					{
						KillEventStart();
						RaiseEventEnd();
					}
					SetCurrentId("0");
					SetListViewColor("0");
					buttonRegister.Enabled = false;
				}
				return false;
			}
			else
			{
				if(itemHolder.ContainsKey(id))
				{
					if(eventEnabled)
					{
						KillEventEnd();
						RaiseEventStart(id);
						if(((Item)itemHolder[id]).programStart != "" || 
							((Item)itemHolder[id]).programEnd != "")
						{
							removedEventId = id;
						}
					}
					SetCurrentId(id);
					SetListViewColor(id);
					buttonRegister.Enabled = false;
					return true;
				}
				else
				{	
					if(eventEnabled)
					{
						KillEventEnd();
					}
					SetCurrentId(id);
					SetListViewColor(id);
					buttonRegister.Enabled = true;
					return false;
				}
			}
		}

		//IDF̃Cxg𔭐
		private void RaiseEventStart(string id)
		{
			if(!eventWorkingStart &&
				((Item)itemHolder[id]).programStart != "")
			{
				this.currentProgram = ((Item)itemHolder[id]).programStart;
				this.currentOptions = ((Item)itemHolder[id]).optionsStart;
				DealEvent((Item)itemHolder[id]);
				eventWorkingStart = true;
				removedEventId = id;
			}
		}
		
		//ID̃Cxg𔭐D
		private void RaiseEventEnd()
		{
			if(!eventWorkingEnd &&
				itemHolder.Contains(removedEventId) &&
				((Item)itemHolder[removedEventId]).programEnd != "")
			{

				this.currentProgram = ((Item)itemHolder[removedEventId]).programEnd;
				this.currentOptions = ((Item)itemHolder[removedEventId]).optionsEnd;
				DealEvent((Item)itemHolder[removedEventId]);
				eventWorkingEnd = true;
			}
		}

		//IDF̃Cxg~D
		private void KillEventStart()
		{
			if(eventWorkingStart)
			{
				if(itemHolder.Contains(removedEventId) &&
					((Item)itemHolder[removedEventId]).programStart != "")
				{
					DealEvent(null);
					eventWorkingStart = false;
				}
			}
			return;
		}

		//ID̃Cxg~D
		private void KillEventEnd()
		{						
			if(eventWorkingEnd)	
			{
				if(itemHolder.Contains(removedEventId) && 
					((Item)itemHolder[removedEventId]).programEnd != "")
				{
					DealEvent(null);
				}
				eventWorkingEnd = false;
			}
			return;
		}
		#endregion

		#region PhidgetServer̐ڑƃXbhJn/~
		//PhidgetServerɐڑ
		public bool Connect(IPAddress ip, int port)
		{
			try
			{
				IPEndPoint ipEndPoint = new IPEndPoint(ip, port);
				phidgetClient = new TcpClient();
				phidgetClient.Connect(ipEndPoint);
				return true;
			}
			catch(Exception  ex)
			{
				PrintError(ex.ToString());
				return false;
			}
		}

		//XbhJn
		private void StartThread()
		{
			if(rxThread == null)
			{
				rxThread = new Thread(new ThreadStart(RxWorker));
				rxThread.Start();
			}
		}

		//Xbh~
		private void StopThread()
		{
			if(rxThread != null)
			{
				rxThread.Abort();
				rxThread = null;
			}
		}

		//AǂݎXbh
		private void RxWorker()
		{
			StreamReader reader = new StreamReader(phidgetClient.GetStream(),System.Text.Encoding.ASCII);
			string id = "0";
			try
			{
				while(true)
				{
					string line = reader.ReadLine();
					PrintDebug(line);
					id = Parse(line);
					CheckMatchId(id);
					Thread.Sleep(rxThreadInterval);
				}
			}
			catch(ThreadAbortException ex)
			{
				return;
			}
			catch(Exception ex)
			{
				PrintError(ex.ToString());
				return;
			}
		}

		private string Parse(string line)
		{
			string id = "0";
				
			string [] args = line.Split(",".ToCharArray());
				
			if(args[0] == "In" && args[1] == "RFID")
				id = args[2];

			return id;
		}
	
		#endregion

		#region GUIR|[lg̏
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.textBoxId = new System.Windows.Forms.TextBox();
			this.labelId = new System.Windows.Forms.Label();
			this.labelRegistedId = new System.Windows.Forms.Label();
			this.buttonRegister = new System.Windows.Forms.Button();
			this.tabControl = new System.Windows.Forms.TabControl();
			this.tabPageId = new System.Windows.Forms.TabPage();
			this.checkBoxEvent = new System.Windows.Forms.CheckBox();
			this.listViewId = new System.Windows.Forms.ListView();
			this.columnHeaderId = new System.Windows.Forms.ColumnHeader();
			this.columnHeaderName = new System.Windows.Forms.ColumnHeader();
			this.tabPageDebug = new System.Windows.Forms.TabPage();
			this.checkBoxMessage = new System.Windows.Forms.CheckBox();
			this.textBoxMessage = new System.Windows.Forms.TextBox();
			this.statusBar = new System.Windows.Forms.StatusBar();
			this.groupBoxNet = new System.Windows.Forms.GroupBox();
			this.numericUpDownPort = new System.Windows.Forms.NumericUpDown();
			this.labelPort = new System.Windows.Forms.Label();
			this.labelIp = new System.Windows.Forms.Label();
			this.textBoxIp = new System.Windows.Forms.TextBox();
			this.buttonConnect = new System.Windows.Forms.Button();
			this.buttonDisconnect = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.tabControl.SuspendLayout();
			this.tabPageId.SuspendLayout();
			this.tabPageDebug.SuspendLayout();
			this.groupBoxNet.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownPort)).BeginInit();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// textBoxId
			// 
			this.textBoxId.Location = new System.Drawing.Point(80, 16);
			this.textBoxId.Name = "textBoxId";
			this.textBoxId.Size = new System.Drawing.Size(120, 19);
			this.textBoxId.TabIndex = 8;
			this.textBoxId.Text = "";
			// 
			// labelId
			// 
			this.labelId.Location = new System.Drawing.Point(8, 16);
			this.labelId.Name = "labelId";
			this.labelId.Size = new System.Drawing.Size(56, 16);
			this.labelId.TabIndex = 9;
			this.labelId.Text = "^OID";
			// 
			// labelRegistedId
			// 
			this.labelRegistedId.Location = new System.Drawing.Point(8, 48);
			this.labelRegistedId.Name = "labelRegistedId";
			this.labelRegistedId.Size = new System.Drawing.Size(48, 16);
			this.labelRegistedId.TabIndex = 11;
			this.labelRegistedId.Text = "o^ID";
			// 
			// buttonRegister
			// 
			this.buttonRegister.Enabled = false;
			this.buttonRegister.Location = new System.Drawing.Point(216, 16);
			this.buttonRegister.Name = "buttonRegister";
			this.buttonRegister.Size = new System.Drawing.Size(72, 23);
			this.buttonRegister.TabIndex = 9;
			this.buttonRegister.Text = "IDo^";
			this.buttonRegister.Click += new System.EventHandler(this.buttonRegister_Click);
			// 
			// tabControl
			// 
			this.tabControl.Controls.Add(this.tabPageId);
			this.tabControl.Controls.Add(this.tabPageDebug);
			this.tabControl.Location = new System.Drawing.Point(0, 112);
			this.tabControl.Name = "tabControl";
			this.tabControl.SelectedIndex = 0;
			this.tabControl.Size = new System.Drawing.Size(312, 184);
			this.tabControl.TabIndex = 8;
			// 
			// tabPageId
			// 
			this.tabPageId.Controls.Add(this.checkBoxEvent);
			this.tabPageId.Controls.Add(this.listViewId);
			this.tabPageId.Controls.Add(this.textBoxId);
			this.tabPageId.Controls.Add(this.labelId);
			this.tabPageId.Controls.Add(this.buttonRegister);
			this.tabPageId.Controls.Add(this.labelRegistedId);
			this.tabPageId.Location = new System.Drawing.Point(4, 21);
			this.tabPageId.Name = "tabPageId";
			this.tabPageId.Size = new System.Drawing.Size(304, 159);
			this.tabPageId.TabIndex = 1;
			this.tabPageId.Text = "IDǗ";
			// 
			// checkBoxEvent
			// 
			this.checkBoxEvent.Location = new System.Drawing.Point(80, 48);
			this.checkBoxEvent.Name = "checkBoxEvent";
			this.checkBoxEvent.Size = new System.Drawing.Size(120, 16);
			this.checkBoxEvent.TabIndex = 17;
			this.checkBoxEvent.Text = "Cxg𐶐";
			this.checkBoxEvent.CheckedChanged += new System.EventHandler(this.checkBoxEvent_CheckedChanged);
			// 
			// listViewId
			// 
			this.listViewId.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						 this.columnHeaderId,
																						 this.columnHeaderName});
			this.listViewId.GridLines = true;
			this.listViewId.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.listViewId.Location = new System.Drawing.Point(8, 72);
			this.listViewId.MultiSelect = false;
			this.listViewId.Name = "listViewId";
			this.listViewId.Size = new System.Drawing.Size(288, 88);
			this.listViewId.TabIndex = 16;
			this.listViewId.View = System.Windows.Forms.View.Details;
			this.listViewId.KeyDown += new System.Windows.Forms.KeyEventHandler(this.listViewId_KeyDown);
			this.listViewId.DoubleClick += new System.EventHandler(this.listViewId_DoubleClick);
			// 
			// columnHeaderId
			// 
			this.columnHeaderId.Text = "ID";
			this.columnHeaderId.Width = 120;
			// 
			// columnHeaderName
			// 
			this.columnHeaderName.Text = "Name";
			this.columnHeaderName.Width = 140;
			// 
			// tabPageDebug
			// 
			this.tabPageDebug.Controls.Add(this.checkBoxMessage);
			this.tabPageDebug.Controls.Add(this.textBoxMessage);
			this.tabPageDebug.Location = new System.Drawing.Point(4, 21);
			this.tabPageDebug.Name = "tabPageDebug";
			this.tabPageDebug.Size = new System.Drawing.Size(304, 159);
			this.tabPageDebug.TabIndex = 2;
			this.tabPageDebug.Text = "fobO";
			// 
			// checkBoxMessage
			// 
			this.checkBoxMessage.Checked = true;
			this.checkBoxMessage.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxMessage.Location = new System.Drawing.Point(16, 8);
			this.checkBoxMessage.Name = "checkBoxMessage";
			this.checkBoxMessage.Size = new System.Drawing.Size(136, 24);
			this.checkBoxMessage.TabIndex = 3;
			this.checkBoxMessage.Text = "bZ[W\";
			this.checkBoxMessage.CheckedChanged += new System.EventHandler(this.checkBoxMessage_CheckedChanged);
			// 
			// textBoxMessage
			// 
			this.textBoxMessage.Location = new System.Drawing.Point(8, 32);
			this.textBoxMessage.Multiline = true;
			this.textBoxMessage.Name = "textBoxMessage";
			this.textBoxMessage.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.textBoxMessage.Size = new System.Drawing.Size(280, 120);
			this.textBoxMessage.TabIndex = 2;
			this.textBoxMessage.Text = "";
			// 
			// statusBar
			// 
			this.statusBar.Location = new System.Drawing.Point(0, 298);
			this.statusBar.Name = "statusBar";
			this.statusBar.Size = new System.Drawing.Size(306, 22);
			this.statusBar.SizingGrip = false;
			this.statusBar.TabIndex = 14;
			// 
			// groupBoxNet
			// 
			this.groupBoxNet.Controls.Add(this.numericUpDownPort);
			this.groupBoxNet.Controls.Add(this.labelPort);
			this.groupBoxNet.Controls.Add(this.labelIp);
			this.groupBoxNet.Controls.Add(this.textBoxIp);
			this.groupBoxNet.Location = new System.Drawing.Point(8, 56);
			this.groupBoxNet.Name = "groupBoxNet";
			this.groupBoxNet.Size = new System.Drawing.Size(288, 48);
			this.groupBoxNet.TabIndex = 19;
			this.groupBoxNet.TabStop = false;
			this.groupBoxNet.Text = "PhidgetServer̐ݒ";
			// 
			// numericUpDownPort
			// 
			this.numericUpDownPort.Location = new System.Drawing.Point(200, 16);
			this.numericUpDownPort.Maximum = new System.Decimal(new int[] {
																			  100000,
																			  0,
																			  0,
																			  0});
			this.numericUpDownPort.Name = "numericUpDownPort";
			this.numericUpDownPort.Size = new System.Drawing.Size(56, 19);
			this.numericUpDownPort.TabIndex = 16;
			this.numericUpDownPort.Value = new System.Decimal(new int[] {
																			4321,
																			0,
																			0,
																			0});
			// 
			// labelPort
			// 
			this.labelPort.Location = new System.Drawing.Point(152, 24);
			this.labelPort.Name = "labelPort";
			this.labelPort.Size = new System.Drawing.Size(40, 16);
			this.labelPort.TabIndex = 15;
			this.labelPort.Text = "|[g:";
			// 
			// labelIp
			// 
			this.labelIp.Location = new System.Drawing.Point(16, 24);
			this.labelIp.Name = "labelIp";
			this.labelIp.Size = new System.Drawing.Size(24, 16);
			this.labelIp.TabIndex = 14;
			this.labelIp.Text = "IP:";
			// 
			// textBoxIp
			// 
			this.textBoxIp.Location = new System.Drawing.Point(56, 16);
			this.textBoxIp.Name = "textBoxIp";
			this.textBoxIp.Size = new System.Drawing.Size(80, 19);
			this.textBoxIp.TabIndex = 13;
			this.textBoxIp.Text = "127.0.0.1";
			// 
			// buttonConnect
			// 
			this.buttonConnect.Location = new System.Drawing.Point(16, 16);
			this.buttonConnect.Name = "buttonConnect";
			this.buttonConnect.Size = new System.Drawing.Size(56, 23);
			this.buttonConnect.TabIndex = 17;
			this.buttonConnect.Text = "ڑ";
			this.buttonConnect.Click += new System.EventHandler(this.buttonConnect_Click);
			// 
			// buttonDisconnect
			// 
			this.buttonDisconnect.Enabled = false;
			this.buttonDisconnect.Location = new System.Drawing.Point(88, 16);
			this.buttonDisconnect.Name = "buttonDisconnect";
			this.buttonDisconnect.Size = new System.Drawing.Size(56, 23);
			this.buttonDisconnect.TabIndex = 18;
			this.buttonDisconnect.Text = "ؒf";
			this.buttonDisconnect.Click += new System.EventHandler(this.buttonDisconnect_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.buttonConnect);
			this.groupBox1.Controls.Add(this.buttonDisconnect);
			this.groupBox1.Location = new System.Drawing.Point(8, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(288, 48);
			this.groupBox1.TabIndex = 32;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "R}h";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(306, 320);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.groupBoxNet);
			this.Controls.Add(this.statusBar);
			this.Controls.Add(this.tabControl);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "MainForm";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.Text = "PhidgetLauncher";
			this.tabControl.ResumeLayout(false);
			this.tabPageId.ResumeLayout(false);
			this.tabPageDebug.ResumeLayout(false);
			this.groupBoxNet.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownPort)).EndInit();
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region bZ[W֘Ã\bh
		public bool MessageEnabled
		{
			get{return messageEnabled;}
		}

		public void PrintStatus(string m, params object []args)
		{
			this.statusMessage = String.Format(m,args);
			this.statusBar.Invoke(new EventHandler(StatusBarMessageUpdate));

		}

		public void PrintMessage(string m, params object []args)
		{
			if(textBoxMessage.TextLength > TEXTBOX_CNT_MAX)
				textBoxMessage.Clear();
			textBoxMessage.Text = String.Format(m,args) + "\r\n" + textBoxMessage.Text;	
		}

		public void PrintDebug(string m, params object []args)
		{
			if(checkBoxMessage.Checked)
			{
				PrintMessage(m,args);
			}
		}

		public void PrintError(string m, params object []args)
		{
			PrintMessage("Error: " + m,args);
		}

		//UIR|[lg̍XV
		private void StatusBarMessageUpdate(object sender, EventArgs e)
		{
			lock(this)
			{
				this.statusBar.Text = this.statusMessage;
			}
			this.statusBar.Update();
		}

		//UIR|[lg̍XV
		private void TextBoxMessageUpdate(object sender, EventArgs e)
		{
			lock(this)
			{
				this.textBoxMessage.Text = this.message + "\r\n" + textBoxMessage.Text;
			}
			this.textBoxMessage.Update();
		}
		#endregion

		#region GUIR|[lg̃Cxg

		//IDݒ
		public void SetCurrentId(string id)
		{
			currentId = id;
			this.textBoxId.Invoke(new EventHandler(TextBoxIdUpdate));
		}

		//ID擾
		public string GetCurrentId()
		{
			return currentId;
		}

		//UIR|[lg̍XV
		private void TextBoxIdUpdate(object sender, EventArgs e)
		{
			lock(this)
			{
				if(currentId == "0")
					textBoxId.Text = "No Card";
				else
					textBoxId.Text = currentId.ToString();
			}
			this.textBoxId.Update();
		}
	
		//ݔFĂJ[hIDnbV/Xg{bNXɓo^D
		private void buttonRegister_Click(object sender, System.EventArgs e)
		{
			string idStr = GetCurrentId().ToString();

			bool existFlag = false;
			foreach(ListViewItem item in listViewId.Items)
			{
				if(item.SubItems[0].Text == idStr)
				{
					existFlag = true;
					break;
				}
			}

			if(existFlag)
			{
				string m = "Error: ID͊ɓo^ς݂łD";
				PrintMessage(m);
				PrintStatus(m);
			}
			else
			{
				string id = idStr;
				string m = "IDo^܂D";
				PrintMessage(m);
				PrintStatus(m);

				if(!itemHolder.ContainsKey(id))
				{
					Item item = new Item(id, "","","","","");
					itemHolder.Add(id, item);
				}

				if(listViewId.Items.Count == 1 && (string)listViewId.Items[0].SubItems[0].Text == "")
				{
					string []subItems = {idStr, ""};
					listViewId.Items[0] = new ListViewItem(subItems);
				}
				else
				{
					string []subItems = {idStr, ""};
					listViewId.Items.Add(new ListViewItem(subItems));
				}
			}
		}

		private void listViewId_DoubleClick(object sender, System.EventArgs e)
		{
			if(listViewId.SelectedItems.Count == 0)
			{
				return;
			}

			string id = listViewId.SelectedItems[0].SubItems[0].Text;
			Item item = null;

			if(itemHolder.ContainsKey(id))
			{
				item = (Item)itemHolder[id];
			}
			else
			{
				item = new Item(id,"","","","","");
			}

			ItemForm form = new ItemForm(item);
			DialogResult result = form.ShowDialog(this);

			if(result == DialogResult.OK)
			{
				if(itemHolder.ContainsKey(id))
				{
					itemHolder[id] = item;
				}
				else
				{
					itemHolder.Add(id, item);
				}

				listViewId.SelectedItems[0].SubItems[1].Text = item.name.ToString();
			}
			form.Dispose();
		}

		private void listViewId_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if(e.KeyCode ==Keys.Delete)
			{
				int index = listViewId.SelectedIndices[0];
				string id = (string)listViewId.Items[index].SubItems[0].Text;
				if(listViewId.Items[index] != null)
				{
					if(itemHolder.Contains(id))
					{
						itemHolder.Remove(id);
					}
					listViewId.Items.RemoveAt(index);
				}
			}
		}

		private void SetListViewColor(string id)
		{
			foreach(ListViewItem li in listViewId.Items)
			{
				if(id == "0")
				{
					li.ForeColor = Color.Black;
				}
				else
				{
					if(li.SubItems[0].Text == id.ToString())
					{
						li.ForeColor = Color.Red;
					}
				}
			}
			return;
		}

		private void buttonConnect_Click(object sender, System.EventArgs e)
		{
			if(!Connect(IPAddress.Parse(textBoxIp.Text), (int)numericUpDownPort.Value))
				return;
		
			string m = String.Format("PhidgetServerɐڑ܂.[{0}:{1}]", 
				textBoxIp.Text, numericUpDownPort.Value.ToString());
			PrintStatus(m);
			PrintMessage(m);

			StartThread();
			buttonConnect.Enabled = false;
			buttonDisconnect.Enabled = true;
		}

		private void buttonDisconnect_Click(object sender, System.EventArgs e)
		{
			
			StopThread();
			if(phidgetClient!=null)
				phidgetClient.Close();
		
			string m = String.Format("PhidgetServerؒf܂");
			PrintStatus(m);
			PrintMessage(m);

			buttonConnect.Enabled = true;
			buttonDisconnect.Enabled = false;
		
		}

		private void checkBoxMessage_CheckedChanged(object sender, System.EventArgs e)
		{
			messageEnabled = checkBoxMessage.Checked;
		}

		private void checkBoxEvent_CheckedChanged(object sender, System.EventArgs e)
		{
			eventEnabled = checkBoxEvent.Checked;
		}

		#endregion

		#region Save/Load̏

		//ݒt@C̕ۑ
		private void SaveSettings()
		{
			StreamWriter fileStream = null;
			try
			{
				fileStream = new StreamWriter(settingFileName, false);
				fileStream.WriteLine(@"#Setting: IntervalTime, MessageEnabled, eventEnabled");
				fileStream.WriteLine(String.Format("{0}\t{1}\t{2}", rxThreadInterval, messageEnabled, eventEnabled));
			}
			catch(IOException ex)
			{
				PrintError(ex.ToString());
			}
			finally
			{
				if(fileStream != null)
				{
					fileStream.Close();
					fileStream = null;		
				}
			}
		}

		//ݒt@C̓ǂݏo
		private void LoadSettings()
		{
			StreamReader fileStream = null;
			string line;
			try
			{
				//t@CȂΏI
				if(!File.Exists(settingFileName))
					return;

				fileStream = new StreamReader(settingFileName);//,  DefaultEncoding

				while(true)
				{
					string [] lineParams;
					line = fileStream.ReadLine();

					if(line == null)
						break;

					if(line.StartsWith(@"#"))
						continue;
					
					lineParams = line.Split(@"\t".ToCharArray());

					if(lineParams.Length < 3)
						continue;

					rxThreadInterval = int.Parse(lineParams[0]);
					messageEnabled = bool.Parse(lineParams[1]);
					eventEnabled = bool.Parse(lineParams[2]);
					break;
				}
			}
			catch(IOException ex)
			{
				PrintError(ex.ToString());
			}
			finally
			{
				if(fileStream != null)
				{
					fileStream.Close();
					fileStream = null;
				}
			}
		}

		//o^ꂽItem̏t@CɕۑD
		private void SaveItems()
		{	
			StreamWriter writer = new StreamWriter(itemFileName, false);

			try
			{
				foreach(Item item in itemHolder.Values)
				{
				
					if(item == null)	break;

					//IvVP̕ɕϊ
					string optionStart = null, optionEnd = null;
					foreach(string option in item.optionsStart)
					{
						optionStart  = optionStart +  Item.DELIMITER + option;
					}
					foreach(string option in item.optionsEnd)
					{
						optionEnd  = optionEnd +  Item.DELIMITER + option;
					}
					//擪Separator폜
					optionStart = Regex.Replace(optionStart, @"^" + Item.DELIMITER ,"");		
					optionEnd = Regex.Replace(optionEnd, @"^" + Item.DELIMITER ,"");	

					string message = string.Format("{0}\t{1}\t{2}\t{3}\t{4}\t{5}",item.id, item.name, item.programStart, optionStart, item.programEnd, optionEnd);
					writer.WriteLine(message);
				}
			}
			catch(Exception ex)
			{
				PrintError(ex.ToString());
			}
			writer.Close();
		}
		
		//t@Co^ꂽACe[hCnbVɉDD
		private void LoadItems()
		{
			if(!File.Exists(itemFileName)) return;

			StreamReader reader = new StreamReader(itemFileName);

			try
			{
				while(true)
				{
					string line = reader.ReadLine();
					if(line == null) 
						break;
					string [] data = line.Split('\t');
					if(data.Length<3)
						continue;

					string id =	data[0];
					string name = data[1];
					string programStart = data[2];
					string optionStart = data[3];
					string programEnd = data[4];
					string optionEnd = data[5];

					itemHolder.Add(id, new Item(id, name, programStart, optionStart, programEnd, optionEnd));

					if(listViewId.Items.Count == 1 && (string)listViewId.Items[0].SubItems[0].Text == "")
					{
						string []subItems = {id.ToString(), ""};
						listViewId.Items[0] = new ListViewItem(subItems);
					}
					else
					{
						string []subItems = {id.ToString(), name.ToString()};
						listViewId.Items.Add(new ListViewItem(subItems));
					}
				}
			}
			catch(Exception ex)
			{
				PrintError(ex.ToString());
			}
			reader.Close();
		}
		#endregion


		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}



	}
}
